diff --git a/test/data/json.org/1.json.ubjson b/test/data/json.org/1.json.ubjson
new file mode 100644
index 00000000..f6029e90
--- /dev/null
+++ b/test/data/json.org/1.json.ubjson
@@ -0,0 +1,2 @@
+{iglossary{iGlossDiv{i	GlossList{i
+GlossEntry{iAbbrevSi
ISO 8879:1986iAcronymSiSGMLiGlossDef{iGlossSeeAlso[SiGMLSiXML]iparaSiHA meta-markup language, used to create markup languages such as DocBook.}iGlossSeeSimarkupi	GlossTermSi$Standard Generalized Markup LanguageiIDSiSGMLiSortAsSiSGML}}ititleSiS}ititleSiexample glossary}}
\ No newline at end of file
diff --git a/test/data/json.org/2.json.ubjson b/test/data/json.org/2.json.ubjson
new file mode 100644
index 00000000..ff8fd4a0
--- /dev/null
+++ b/test/data/json.org/2.json.ubjson
@@ -0,0 +1,2 @@
+{imenu{iidSifileipopup{imenuitem[{ionclickSiCreateNewDoc()ivalueSiNew}{ionclickSi	OpenDoc()ivalueSiOpen}{ionclickSi
+CloseDoc()ivalueSiClose}]}ivalueSiFile}}
\ No newline at end of file
diff --git a/test/data/json.org/3.json.ubjson b/test/data/json.org/3.json.ubjson
new file mode 100644
index 00000000..e3b6bafa
--- /dev/null
+++ b/test/data/json.org/3.json.ubjson
@@ -0,0 +1,2 @@
+{iwidget{idebugSioniimage{i	alignmentSicenterihOffsetUúinameSisun1isrcSiImages/Sun.pngivOffsetUú}itext{i	alignmentSicenteridataSi
+Click HereihOffsetUúinameSitext1i	onMouseUpSi)sun1.opacity = (sun1.opacity / 100) * 90;isizei$istyleSiboldivOffsetid}iwindow{iheightIôinameSimain_windowititleSiSample Konfabulator WidgetiwidthIô}}}
\ No newline at end of file
diff --git a/test/data/json.org/4.json.ubjson b/test/data/json.org/4.json.ubjson
new file mode 100644
index 00000000..a31e3fd7
Binary files /dev/null and b/test/data/json.org/4.json.ubjson differ
diff --git a/test/data/json.org/5.json.ubjson b/test/data/json.org/5.json.ubjson
new file mode 100644
index 00000000..dcb888d7
--- /dev/null
+++ b/test/data/json.org/5.json.ubjson
@@ -0,0 +1,5 @@
+{imenu{iheaderSi
+SVG Vieweriitems[{iidSiOpen}{iidSiOpenNewilabelSiOpen New}Z{iidSiZoomInilabelSiZoom In}{iidSiZoomOutilabelSiZoom Out}{iidSiOriginalViewilabelSi
Original View}Z{iidSiQuality}{iidSiPause}{iidSiMute}Z{iidSiFindilabelSiFind...}{iidSi	FindAgainilabelSi
+Find Again}{iidSiCopy}{iidSi	CopyAgainilabelSi
+Copy Again}{iidSiCopySVGilabelSiCopy SVG}{iidSiViewSVGilabelSiView SVG}{iidSi
+ViewSourceilabelSiView Source}{iidSiSaveAsilabelSiSave As}Z{iidSiHelp}{iidSiAboutilabelSiAbout Adobe CVG Viewer...}]}}
\ No newline at end of file
diff --git a/test/data/json_nlohmann_tests/all_unicode.json.ubjson b/test/data/json_nlohmann_tests/all_unicode.json.ubjson
new file mode 100644
index 00000000..13ff98b5
Binary files /dev/null and b/test/data/json_nlohmann_tests/all_unicode.json.ubjson differ
diff --git a/test/data/json_tests/pass1.json.ubjson b/test/data/json_tests/pass1.json.ubjson
new file mode 100644
index 00000000..4d9f1a9a
Binary files /dev/null and b/test/data/json_tests/pass1.json.ubjson differ
diff --git a/test/data/json_tests/pass2.json.ubjson b/test/data/json_tests/pass2.json.ubjson
new file mode 100644
index 00000000..e2bf4bda
--- /dev/null
+++ b/test/data/json_tests/pass2.json.ubjson
@@ -0,0 +1 @@
+[[[[[[[[[[[[[[[[[[[SiNot too deep]]]]]]]]]]]]]]]]]]]
\ No newline at end of file
diff --git a/test/data/json_tests/pass3.json.ubjson b/test/data/json_tests/pass3.json.ubjson
new file mode 100644
index 00000000..c29a1922
--- /dev/null
+++ b/test/data/json_tests/pass3.json.ubjson
@@ -0,0 +1 @@
+{iJSON Test Pattern pass3{iIn this testSiIt is an object.iThe outermost valueSimust be an object or array.}}
\ No newline at end of file
diff --git a/test/data/json_testsuite/sample.json.ubjson b/test/data/json_testsuite/sample.json.ubjson
new file mode 100644
index 00000000..21df139b
Binary files /dev/null and b/test/data/json_testsuite/sample.json.ubjson differ
diff --git a/test/src/unit-ubjson.cpp b/test/src/unit-ubjson.cpp
index a1830d62..291093c4 100644
--- a/test/src/unit-ubjson.cpp
+++ b/test/src/unit-ubjson.cpp
@@ -2111,6 +2111,12 @@ TEST_CASE("UBJSON roundtrips", "[hide]")
     {
         for (std::string filename :
                 {
+                    "test/data/json_nlohmann_tests/all_unicode.json",
+                    "test/data/json.org/1.json",
+                    "test/data/json.org/2.json",
+                    "test/data/json.org/3.json",
+                    "test/data/json.org/4.json",
+                    "test/data/json.org/5.json",
                     "test/data/json_roundtrip/roundtrip01.json",
                     "test/data/json_roundtrip/roundtrip02.json",
                     "test/data/json_roundtrip/roundtrip03.json",
@@ -2142,7 +2148,11 @@ TEST_CASE("UBJSON roundtrips", "[hide]")
                     "test/data/json_roundtrip/roundtrip29.json",
                     "test/data/json_roundtrip/roundtrip30.json",
                     "test/data/json_roundtrip/roundtrip31.json",
-                    "test/data/json_roundtrip/roundtrip32.json"
+                    "test/data/json_roundtrip/roundtrip32.json",
+                    "test/data/json_testsuite/sample.json",
+                    "test/data/json_tests/pass1.json",
+                    "test/data/json_tests/pass2.json",
+                    "test/data/json_tests/pass3.json"
                 })
         {
             CAPTURE(filename);
